<template>
  <div>
    <button class="btn bg-white capsule btn-sm mr-2" @click="showModal()">Handle</button>
    <lenna-modal ref="thisModal">
      <div class="col-sm-3" slot="action">
        <button
          class="btn-block btn btn-primary text-white btn-rounded"
          @click="handleLiveChat"
        >Handle</button>
      </div>
    </lenna-modal>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
import * as httpHelper from "@/helpers/httpHelper";

export default {
  data() {
    return {};
  },
  props: ["selectedRoom"],
  methods: {
    hideModal() {
      EventBus.$emit("hideModal");
    },
    showModal() {
      this.$emit("show");
      this.$refs.thisModal.show(
        "info",
        `Do you really want to process this chat?`,
        `This process cannot be undone`
      );
    },
    async handleLiveChat() {
      this.hideModal();
      try {
        let response = await this.$axios.post(
          `api/${this.$store.getters.appId.hashed}/livechat/handle`,
          {
            room: this.selectedRoom,
            agentId: this.$store.getters.localStorage.decodedUserId
          }
        );
        this.$store.dispatch("chat/liveChatUpdate", {
          room: this.selectedRoom,
          liveChat: response.data.data.liveChat,
          status: "live"
        });

        httpHelper.successToast(this, response.data.message);
      } catch (error) {
        httpHelper.errorToast(this, error);
      }
    }
  }
};
</script>
<style lang="scss" scoped>
</style>